/**********************************************************/
/* mm.c version 1.2     modified by Kenji KISE 2004-10-27 */
/**********************************************************/
#include <stdio.h>
#include <jia.h>

/* small  data set : 1024 */
/* mediun data set : 2048 */
/* large  data set : 3072 */
/**************************/
#define N (1024 * 2)

double (*a)[N], (*b)[N], (*c)[N];

/**********************************************************/
void seqinit(){
  int i,j;
  
  if(jiapid==0){
    for(i=0; i<N; i++){
      for(j=0; j<N; j++){
	a[i][j]=1.0;
	b[i][j]=1.0;
      }
    }
  }
}

/**********************************************************/
void worker(){
  int i,j,k;
  int start, end;
  double temp;
  
  start = (N/jiahosts)*jiapid;
  end   = start+(N/jiahosts);
  if(jiapid==(jiahosts-1)) end = N; /* This is the key. */
  
  for(j=0; j<N; j++){ 
    for(i=start; i<end; i++){
      temp=0.0;
      for(k=0; k<N; k++){
	temp += a[i][k] * b[j][k]; /* page transfer here */
      }
      c[i][j]=temp;                /* page transfer here */
    }
  }
}

/**********************************************************/
int main(int argc,char **argv){
  float t1,t2;
  int dsize = N * N * sizeof(double);
  
  jia_init(argc,argv);
  
  a=(double (*)[N])jia_alloc3(dsize, dsize/jiahosts, 0);
  b=(double (*)[N])jia_alloc3(dsize, dsize/jiahosts, 0);
  c=(double (*)[N])jia_alloc3(dsize, dsize/jiahosts, 0);
  
  jia_barrier();
  
  seqinit();
  
  jia_barrier();
  t1 = jia_clock();
  jia_barrier();
  
  worker();
  
  jia_barrier();
  t2 = jia_clock();
  jia_barrier();

  if(jiapid==0){
    int i,j;
    double sum=0.0;
    long long answer;
    for(i=0; i<N; i++){
      for(j=0; j<N; j++){
	sum = sum + c[i][j];
      }
    }
    answer  = N * N;
    answer *= N;

    printf("----------------------------------------\n");
    printf("number of nodes   : %d\n", hostc);
    printf("MM matrix size N  : %d\n", N);
    printf("shared memory (MB): %d\n", dsize*3/1024/1024);
    printf("elapsed time (sec): %.2f\n", t2-t1);
    printf("check sum         : %.2f\n", sum);
    printf("check sum         : %lld\n", answer);
    printf("node_time: %3d %7.2f\n", hostc, t2-t1);
    printf("----------------------------------------\n");
    fflush(stdout);
  }

  jia_barrier();

  jia_exit();
  return 0;
} 
/**********************************************************/
